diff --git a/drupal7/sites/all/modules/file_entity/plugins/tasks/file_view.inc b/drupal7/sites/all/modules/file_entity/plugins/tasks/file_view.inc
new file mode 100644
index 00000000..5b823758
--- /dev/null
+++ b/drupal7/sites/all/modules/file_entity/plugins/tasks/file_view.inc
@@ -0,0 +1,164 @@
+<?php
+
+/**
+ * @file
+ * Handle the 'file view' override task.
+ *
+ * This plugin overrides file/%file and reroutes it to the page manager, where
+ * a list of tasks can be used to service this request based upon criteria
+ * supplied by access plugins.
+ */
+
+/**
+ * Specialized implementation of hook_page_manager_task_tasks().
+ */
+function file_entity_file_view_page_manager_tasks() {
+  return array(
+    // This is a 'page' task and will fall under the page admin UI
+    'task type' => 'page',
+    'title' => t('File template'),
+    'admin title' => t('File template'),
+    'admin description' => t('When enabled, this overrides the default Drupal behavior for displaying files at <em>file/%file</em>. If you add variants, you may use selection criteria such as file types or user access to provide different views of files. If no variant is selected, the default Drupal file view will be used. This page only affects files viewed as pages, it will not affect files viewed in lists or at other locations. Also please note that if you are using Pathauto, aliases may make a file to be available somewhere else, but as far as Drupal is concerned, they are still at file/%file.'),
+    'admin path' => 'file/%file',
+
+    // Menu hooks so that we can alter the file/%file menu entry to point to us.
+    'hook menu' => 'file_entity_file_view_menu',
+    'hook menu alter' => 'file_entity_file_view_menu_alter',
+
+    // This is task uses 'context' handlers and must implement these to give the
+    // handler data it needs.
+    'handler type' => 'context',
+    'get arguments' => 'file_entity_file_view_get_arguments',
+    'get context placeholders' => 'file_entity_file_view_get_contexts',
+
+    // Allow this to be enabled or disabled:
+    'disabled' => variable_get('file_entity_file_view_disabled', TRUE),
+    'enable callback' => 'file_entity_file_view_enable',
+    'access callback' => 'file_entity_file_view_access_check',
+  );
+}
+
+/**
+ * Callback defined by page_manager_file_view_page_manager_tasks().
+ *
+ * Alter the file view input so that file view comes to us rather than the
+ * normal file view process.
+ */
+function file_entity_file_view_menu_alter(&$items, $task) {
+  if (variable_get('file_entity_file_view_disabled', TRUE)) {
+    return;
+  }
+
+  // Override the node view handler for our purpose.
+  $callback = $items['file/%file']['page callback'];
+  if ($callback == 'file_entity_view_page' || variable_get('page_manager_override_anyway', FALSE)) {
+    $items['file/%file']['page callback'] = 'file_entity_file_view_page';
+    $items['file/%file']['file path'] = $task['path'];
+    $items['file/%file']['file'] = $task['file'];
+  }
+  else {
+    // automatically disable this task if it cannot be enabled.
+    variable_set('file_entity_file_view_disabled', TRUE);
+    if (!empty($GLOBALS['page_manager_enabling_file_view'])) {
+      drupal_set_message(t('Page manager module is unable to enable file/%file because some other module already has overridden with %callback.', array('%callback' => $callback)), 'error');
+    }
+  }
+}
+
+/**
+ * Entry point for our overridden file view.
+ *
+ * This function asks its assigned handlers who, if anyone, would like
+ * to run with it. If no one does, it passes through to File entity's
+ * file view, which is file_entity_view_page().
+ */
+function file_entity_file_view_page($file) {
+  // Load my task plugin:
+  $task = page_manager_get_task('file_view');
+
+  // Load the account into a context.
+  ctools_include('context');
+  ctools_include('context-task-handler');
+  $contexts = ctools_context_handler_get_task_contexts($task, '', array($file));
+
+  // We need to mimic Drupal's behavior of setting the file title here.
+  drupal_set_title($file->filename);
+  $uri = entity_uri('file', $file);
+  // Set the file path as the canonical URL to prevent duplicate content.
+  drupal_add_html_head_link(array('rel' => 'canonical', 'href' => url($uri['path'], $uri['options'])), TRUE);
+  // Set the non-aliased path as a default shortlink.
+  drupal_add_html_head_link(array('rel' => 'shortlink', 'href' => url($uri['path'], array_merge($uri['options'], array('alias' => TRUE)))), TRUE);
+  $contexts = ctools_context_handler_get_task_contexts($task, '', array($file));
+
+  $output = ctools_context_handler_render($task, '', $contexts, array($file->fid));
+  if ($output != FALSE) {
+    return $output;
+  }
+
+  $function = 'file_entity_view_page';
+  foreach (module_implements('page_manager_override') as $module) {
+    $call = $module . '_page_manager_override';
+    if (($rc = $call('file_view')) && function_exists($rc)) {
+      $function = $rc;
+      break;
+    }
+  }
+
+  // Otherwise, fall back.
+  return $function($file);
+}
+
+/**
+ * Callback to get arguments provided by this task handler.
+ *
+ * Since this is the file view and there is no UI on the arguments, we
+ * create dummy arguments that contain the needed data.
+ */
+function file_entity_file_view_get_arguments($task, $subtask_id) {
+  return array(
+    array(
+      'keyword' => 'file',
+      'identifier' => t('File being viewed'),
+      'id' => 1,
+      'name' => 'entity_id:file',
+      'settings' => array(),
+    ),
+  );
+}
+
+/**
+ * Callback to get context placeholders provided by this handler.
+ */
+function file_entity_file_view_get_contexts($task, $subtask_id) {
+  return ctools_context_get_placeholders_from_argument(page_manager_file_view_get_arguments($task, $subtask_id));
+}
+
+/**
+ * Callback to enable/disable the page from the UI.
+ */
+function file_entity_file_view_enable($cache, $status) {
+  variable_set('file_entity_file_view_disabled', $status);
+
+  // Set a global flag so that the menu routine knows it needs
+  // to set a message if enabling cannot be done.
+  if (!$status) {
+    $GLOBALS['page_manager_enabling_file_view'] = TRUE;
+  }
+}
+
+/**
+ * Callback to determine if a page is accessible.
+ *
+ * @param $task
+ *   The task plugin.
+ * @param $subtask_id
+ *   The subtask id
+ * @param $contexts
+ *   The contexts loaded for the task.
+ * @return
+ *   TRUE if the current user can access the page.
+ */
+function page_manager_file_view_access_check($task, $subtask_id, $contexts) {
+  $context = reset($contexts);
+  return file_entity_access('view');
+}
diff --git a/drupal7/sites/all/modules/file_entity/tests/file_entity_test.info b/drupal7/sites/all/modules/file_entity/tests/file_entity_test.info
index cf354022..fd1bbc93 100644
--- a/drupal7/sites/all/modules/file_entity/tests/file_entity_test.info
+++ b/drupal7/sites/all/modules/file_entity/tests/file_entity_test.info
@@ -5,9 +5,9 @@ core = 7.x
 dependencies[] = file_entity
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2014-10-04
-version = "7.x-2.0-beta1"
+; Information added by Drupal.org packaging script on 2015-07-14
+version = "7.x-2.0-beta2"
 core = "7.x"
 project = "file_entity"
-datestamp = "1412420930"
+datestamp = "1436896443"
 
diff --git a/drupal7/sites/all/modules/media/includes/media.browser.inc b/drupal7/sites/all/modules/media/includes/media.browser.inc
index d8037221..d5285f0a 100644
--- a/drupal7/sites/all/modules/media/includes/media.browser.inc
+++ b/drupal7/sites/all/modules/media/includes/media.browser.inc
@@ -24,7 +24,8 @@ function media_browser($selected = NULL) {
     }
     $files = file_load_multiple($fids);
     foreach ($files as $file) {
-      media_browser_build_media_item($file);
+      $view_mode = isset($params['view_mode']) ? $params['view_mode'] : 'preview';
+      media_browser_build_media_item($file, $view_mode);
     }
     $setting = array('media' => array('selectedMedia' => array_values($files)));
     drupal_add_js($setting, 'setting');
@@ -148,71 +149,12 @@ function media_browser($selected = NULL) {
   return $output;
 }
 
-/**
- * Attaches media browser javascript to an element.
- *
- * @param array $element
- *   The element array to attach to.
- */
-function media_attach_browser_js(&$element) {
-  $javascript = media_browser_js();
-  foreach ($javascript as $key => $definitions) {
-    foreach ($definitions as $definition) {
-      $element['#attached'][$key][] = $definition;
-    }
-  }
-}
-
-/**
- * Helper function to define browser javascript.
- */
-function media_browser_js() {
-  $settings = array(
-    'browserUrl' => url('media/browser', array(
-      'query' => array(
-        'render' => 'media-popup'
-      ))
-    ),
-    'styleSelectorUrl' => url('media/-media_id-/format-form', array(
-      'query' => array(
-        'render' => 'media-popup'
-      ))
-    ),
-    'dialogOptions' => array(
-      'dialogclass' => variable_get('media_dialogclass', 'media-wrapper'),
-      'modal' => (boolean)variable_get('media_modal', TRUE),
-      'draggable' => (boolean)variable_get('media_draggable', FALSE),
-      'resizable' => (boolean)variable_get('media_resizable', FALSE),
-      'minwidth' => (int)variable_get('media_minwidth', 500),
-      'width' => (int)variable_get('media_width', 670),
-      'height' => (int)variable_get('media_height', 280),
-      'position' => variable_get('media_position', 'center'),
-      'overlay' => array(
-        'backgroundcolor' => variable_get('media_backgroundcolor', '#000000'),
-        'opacity' => (float)variable_get('media_opacity', 0.4),
-      ),
-      'zindex' => (int)variable_get('media_zindex', 10000),
-    ),
-  );
-
-  return array(
-    'library' => array(
-      array('media', 'media_browser'),
-    ),
-    'js' => array(
-      array(
-       'data' => array('media' => $settings),
-       'type' => 'setting',
-      ),
-    ),
-  );
-}
-
 /**
  * Menu callback for testing the media browser.
  */
 function media_browser_testbed($form) {
-  media_attach_browser_js($form);
+  $form['#attached']['library'][] = array('media', 'media_browser');
+  $form['#attached']['library'][] = array('media', 'media_browser_settings');
 
   $form['test_element'] = array(
     '#type' => 'media',
@@ -290,12 +232,13 @@ EOF;
 }
 
 /**
- * Adds properties to the file.
+ * Adds additional properties to a file which are needed by the browser JS code.
  *
- * Additional properties on this file are needed by the media browser JS code.
+ * @param object $file
+ *   A Drupal file object.
  */
-function media_browser_build_media_item($file) {
-  $preview = media_get_thumbnail_preview($file);
+function media_browser_build_media_item($file, $view_mode = 'preview') {
+  $preview = media_get_thumbnail_preview($file, NULL, $view_mode);
   $file->preview = drupal_render($preview);
   $file->url = file_create_url($file->uri);
 }
diff --git a/drupal7/sites/all/modules/media/includes/media.fields.inc b/drupal7/sites/all/modules/media/includes/media.fields.inc
index c3132116..0820fc16 100644
--- a/drupal7/sites/all/modules/media/includes/media.fields.inc
+++ b/drupal7/sites/all/modules/media/includes/media.fields.inc
@@ -15,9 +15,13 @@ function media_field_widget_info() {
       'label' => t('Media browser'),
       'field types' => array('file', 'image'),
       'settings' => array(
-        'allowed_types' => array('image'),
+        'allowed_types' => array(
+          'image' => 'image',
+        ),
         'browser_plugins' => array(),
-        'allowed_schemes' => array('public', 'private'),
+        'allowed_schemes' => array(
+          'public' => 'public',
+        ),
       ),
       'behaviors' => array(
         'multiple values' => FIELD_BEHAVIOR_CUSTOM,
@@ -77,12 +81,6 @@ function media_field_widget_settings_form($field, $instance) {
  * Implements hook_field_widget_form().
  */
 function media_field_widget_form(&$form, &$form_state, $field, $instance, $langcode, $items, $delta, $element) {
-
-  // Add display_field setting to field because media_field_widget_form() assumes it is set.
-  if (!isset($field['settings']['display_field'])) {
-    $field['settings']['display_field'] = 0;
-  }
-
   $defaults = array(
     'fid' => 0,
     'display' => !empty($field['settings']['display_default']),
@@ -164,7 +162,7 @@ function media_field_widget_form(&$form, &$form_state, $field, $instance, $langc
     $elements['#description'] = $element['#description'];
     $elements['#field_name'] = $element['#field_name'];
     $elements['#language'] = $element['#language'];
-    $elements['#display_field'] = $field['settings']['display_field'];
+    $elements['#display_field'] = intval(!empty($field['settings']['display_field']));
 
     // Add some properties that will eventually be added to the media upload
     // field. These are added here so that they may be referenced easily through
@@ -185,7 +183,7 @@ function media_field_widget_value($element, $input = FALSE, $form_state) {
     // If the display field is present make sure its unchecked value is saved.
     $field = field_widget_field($element, $form_state);
     if (empty($input['display'])) {
-      $input['display'] = $field['settings']['display_field'] ? 0 : 1;
+      $input['display'] = intval(!empty($field['settings']['display_field']));
     }
   }
 
@@ -450,7 +448,7 @@ function theme_media_widget_multiple($variables) {
     // "operations" column.
     $operations_elements = array();
     foreach (element_children($widget) as $sub_key) {
-      if (isset($widget[$sub_key]['#type']) && $widget[$sub_key]['#type'] == 'submit') {
+      if (isset($widget[$sub_key]['#type']) && ($widget[$sub_key]['#type'] == 'submit' || $widget[$sub_key]['#type'] == 'link')) {
         hide($widget[$sub_key]);
         $operations_elements[] = &$widget[$sub_key];
       }
@@ -543,11 +541,64 @@ function media_field_formatter_info() {
     'media_large_icon' => array(
       'label' => t('Large filetype icon'),
       'field types' => array('file'),
+      'settings' => array(
+        'image_style' => '',
+      ),
     ),
   );
+
   return $formatters;
 }
 
+/**
+ * Implements hook_field_formatter_settings_form().
+ *
+ * Legacy support for the "Large filetype icon" file field formatter.
+ * @see media_field_formatter_info()
+ */
+function media_field_formatter_settings_form($field, $instance, $view_mode, $form, &$form_state) {
+  $display = $instance['display'][$view_mode];
+  $settings = $display['settings'];
+
+  $image_styles = image_style_options(FALSE, PASS_THROUGH);
+  $element['image_style'] = array(
+    '#title' => t('Image style'),
+    '#type' => 'select',
+    '#default_value' => $settings['image_style'],
+    '#empty_option' => t('None (original image)'),
+    '#options' => $image_styles,
+  );
+
+  return $element;
+}
+
+/**
+ * Implements hook_field_formatter_settings_summary().
+ *
+ * Legacy support for the "Large filetype icon" file field formatter.
+ * @see media_field_formatter_info()
+ */
+function media_field_formatter_settings_summary($field, $instance, $view_mode) {
+  $display = $instance['display'][$view_mode];
+  $settings = $display['settings'];
+
+  $summary = array();
+
+  $image_styles = image_style_options(FALSE, PASS_THROUGH);
+  // Unset possible 'No defined styles' option.
+  unset($image_styles['']);
+  // Styles could be lost because of enabled/disabled modules that defines
+  // their styles in code.
+  if (isset($image_styles[$settings['image_style']])) {
+    $summary[] = t('Image style: @style', array('@style' => $image_styles[$settings['image_style']]));
+  }
+  else {
+    $summary[] = t('Original image');
+  }
+
+  return implode('<br />', $summary);
+}
+
 /**
  * Implements hook_field_formatter_view().
  *
@@ -558,12 +609,11 @@ function media_field_formatter_view($entity_type, $entity, $field, $instance, $l
   $element = array();
 
   if ($display['type'] == 'media_large_icon') {
-    // Use the media_thumbnail image style so that the output in media browser
-    // is consistent.
     foreach ($items as $delta => $item) {
       $element[$delta] = array(
         '#theme' => 'media_formatter_large_icon',
         '#file' => (object) $item,
+        '#style_name' => $display['settings']['image_style'],
       );
     }
   }
diff --git a/drupal7/sites/all/modules/media/js/media.browser.js b/drupal7/sites/all/modules/media/js/media.browser.js
index d16e52aa..88490e59 100644
--- a/drupal7/sites/all/modules/media/js/media.browser.js
+++ b/drupal7/sites/all/modules/media/js/media.browser.js
@@ -30,7 +30,7 @@ Drupal.behaviors.MediaBrowser = {
       }
     };
     var activeTab = Drupal.media.browser.tabFromHash();
-    $('#media-browser-tabset').tabs({
+    $('#media-browser-tabset').once('MediaBrowser').tabs({
       selected: activeTab, // jquery < 1.9
       active: activeTab, // jquery >= 1.9
       show: showFunc, // jquery ui < 1.8
@@ -107,6 +107,11 @@ Drupal.media.browser.selectMedia = function (selectedMedia) {
   Drupal.media.browser.selectedMedia = selectedMedia;
 };
 
+Drupal.media.browser.selectMediaAndSubmit = function (selectedMedia) {
+  Drupal.media.browser.selectedMedia = selectedMedia;
+  Drupal.media.browser.submit();
+};
+
 Drupal.media.browser.finalizeSelection = function () {
   if (!Drupal.media.browser.selectedMedia) {
     throw new exception(Drupal.t('Cannot continue, nothing selected'));
diff --git a/drupal7/sites/all/modules/media/js/plugins/media.views.js b/drupal7/sites/all/modules/media/js/plugins/media.views.js
index b5024b39..455288d6 100644
--- a/drupal7/sites/all/modules/media/js/plugins/media.views.js
+++ b/drupal7/sites/all/modules/media/js/plugins/media.views.js
@@ -80,6 +80,36 @@ Drupal.media.browser.views.setup = function(view) {
   // Reset the list of selected files
   Drupal.media.browser.selectMedia([]);
 
+  // Catch double click to submit a single item.
+  $('.view-content .media-item', view).bind('dblclick', function () {
+    var fid = $(this).closest('.media-item[data-fid]').data('fid'),
+      selectedFiles = new Array();
+
+    // Remove all currently selected files
+    $('.view-content .media-item', view).removeClass('selected');
+
+    // Mark it as selected
+    $(this).addClass('selected');
+
+    // Because the files are added using drupal_add_js() and due to the fact
+    // that drupal_get_js() runs a drupal_array_merge_deep() which re-numbers
+    // numeric key values, we have to search in Drupal.settings.media.files
+    // for the matching file ID rather than referencing it directly.
+    for (index in Drupal.settings.media.files) {
+      if (Drupal.settings.media.files[index].fid == fid) {
+        selectedFiles.push(Drupal.settings.media.files[index]);
+
+        // If multiple tabs contains the same file, it will be present in the
+        // files-array multiple times, so we break out early so we don't have
+        // it in the selectedFiles array multiple times.
+        // This would interfer with multi-selection, so...
+        break;
+      }
+    }
+    Drupal.media.browser.selectMediaAndSubmit(selectedFiles);
+  });
+
+
   // Catch the click on a media item
   $('.view-content .media-item', view).bind('click', function () {
     var fid = $(this).closest('.media-item[data-fid]').data('fid'),
diff --git a/drupal7/sites/all/modules/media/media.api.php b/drupal7/sites/all/modules/media/media.api.php
index 4ff1c4f8..ecde61b2 100644
--- a/drupal7/sites/all/modules/media/media.api.php
+++ b/drupal7/sites/all/modules/media/media.api.php
@@ -14,6 +14,7 @@
  * @return array
  *   The unique URI for the file, based on its stream wrapper, or NULL.
  *
+ * @see hook_media_parse_alter()
  * @see media_parse_to_file()
  * @see media_add_from_url_validate()
  */
@@ -27,6 +28,37 @@ function hook_media_parse($url) {
   }
 }
 
+/**
+ * Alters the parsing of urls and embedded codes into unique URIs.
+ *
+ * @param string $success
+ *   The unique URI for the file, based on its stream wrapper, or NULL.
+ * @param array $context
+ *   A nested array of contextual information containing the following keys:
+ *   - url: The original URL or embed code to parse.
+ *   - module: The name of the module which is attempting to parse the url or
+ *     embedded code into a unique URI.
+ *
+ * @see hook_media_parse()
+ * @see hook_media_browser_plugin_info()
+ * @see media_get_browser_plugin_info()
+ */
+function hook_media_parse_alter(&$success, $context) {
+  $url = $context['url'];
+  $url_info = parse_url($url);
+
+  // Restrict users to only embedding secure links.
+  if ($url_info['scheme'] != 'https') {
+    $success = NULL;
+  }
+
+  // Use a custom handler for detecting YouTube videos.
+  if ($context['module' == 'media_youtube']) {
+    $handler = new CustomYouTubeHandler($url);
+    $success = $handler->parse($url);
+  }
+}
+
 /**
  * Returns a list of plugins for the media browser.
  *
@@ -99,6 +131,7 @@ function hook_media_browser_plugins_alter(&$plugin_output) {
  * @see media_set_browser_params()
  */
 function hook_media_browser_params_alter(&$stored_params) {
+  $stored_params['view_mode'] = 'custom';
   $stored_params['types'][] = 'document';
   unset($stored_params['enabledPlugins'][0]);
 }
diff --git a/drupal7/sites/all/modules/media/media.file_default_displays.inc b/drupal7/sites/all/modules/media/media.file_default_displays.inc
index ec7a378f..3e3e2c13 100644
--- a/drupal7/sites/all/modules/media/media.file_default_displays.inc
+++ b/drupal7/sites/all/modules/media/media.file_default_displays.inc
@@ -15,36 +15,44 @@ function media_file_default_displays() {
   $file_display = new stdClass();
   $file_display->api_version = 1;
   $file_display->name = 'audio__preview__file_field_media_large_icon';
-  $file_display->weight = 50;
+  $file_display->weight = 49;
   $file_display->status = TRUE;
-  $file_display->settings = '';
+  $file_display->settings = array(
+    'image_style' => 'media_thumbnail',
+  );
   $file_displays['audio__preview__file_field_media_large_icon'] = $file_display;
 
   // Document previews should be displayed using a large filetype icon.
   $file_display = new stdClass();
   $file_display->api_version = 1;
   $file_display->name = 'document__preview__file_field_media_large_icon';
-  $file_display->weight = 50;
+  $file_display->weight = 49;
   $file_display->status = TRUE;
-  $file_display->settings = '';
+  $file_display->settings = array(
+    'image_style' => 'media_thumbnail',
+  );
   $file_displays['document__preview__file_field_media_large_icon'] = $file_display;
 
   // Image previews should be displayed using a large filetype icon.
   $file_display = new stdClass();
   $file_display->api_version = 1;
   $file_display->name = 'image__preview__file_field_media_large_icon';
-  $file_display->weight = 50;
+  $file_display->weight = 49;
   $file_display->status = TRUE;
-  $file_display->settings = '';
+  $file_display->settings = array(
+    'image_style' => 'media_thumbnail',
+  );
   $file_displays['image__preview__file_field_media_large_icon'] = $file_display;
 
   // Video previews should be displayed using a large filetype icon.
   $file_display = new stdClass();
   $file_display->api_version = 1;
   $file_display->name = 'video__preview__file_field_media_large_icon';
-  $file_display->weight = 50;
+  $file_display->weight = 49;
   $file_display->status = TRUE;
-  $file_display->settings = '';
+  $file_display->settings = array(
+    'image_style' => 'media_thumbnail',
+  );
   $file_displays['video__preview__file_field_media_large_icon'] = $file_display;
 
   return $file_displays;
diff --git a/drupal7/sites/all/modules/media/media.info b/drupal7/sites/all/modules/media/media.info
index 27a92be0..c7b8f871 100644
--- a/drupal7/sites/all/modules/media/media.info
+++ b/drupal7/sites/all/modules/media/media.info
@@ -24,9 +24,9 @@ configure = admin/config/media/browser
 ; We have to add a fake version so Git checkouts do not fail Media dependencies
 version = 7.x-2.x-dev
 
-; Information added by Drupal.org packaging script on 2014-10-04
-version = "7.x-2.0-alpha4"
+; Information added by Drupal.org packaging script on 2015-07-14
+version = "7.x-2.0-beta1"
 core = "7.x"
 project = "media"
-datestamp = "1412422430"
+datestamp = "1436895542"
 
diff --git a/drupal7/sites/all/modules/media/media.install b/drupal7/sites/all/modules/media/media.install
index 43a17456..1e7ae31d 100644
--- a/drupal7/sites/all/modules/media/media.install
+++ b/drupal7/sites/all/modules/media/media.install
@@ -104,7 +104,7 @@ function media_update_dependencies() {
 function media_requirements($phase) {
   $t = get_t();
   // Make sure that file_entity module is 2.x version.
-  // We can't add this check in .info file because drupal.org testbot cant
+  // We can't add this check in .info file because drupal.org testbot can't
   // handle it. See #1734648.
   $requirements = array();
 
@@ -139,6 +139,10 @@ function media_update_7001() {
  * Create the media_type table from the media_types variable.
  */
 function media_update_7002() {
+  if (db_table_exists('media_type')) {
+    return;
+  }
+
   $schema['media_type'] = array(
     'description' => 'Stores the settings for media types.',
     'fields' => array(
@@ -190,7 +194,7 @@ function media_update_7002() {
   db_create_table('media_type', $schema['media_type']);
 
   drupal_load('module', 'media');
-  $old_types = variable_get('media_types');
+  $old_types = variable_get('media_types', array());
   foreach ($old_types as $type) {
     // Was an error in the original creation.
     if (isset($type->callbacks)) {
@@ -496,6 +500,13 @@ function media_update_7020() {
   }
 }
 
+/**
+ * Rerun media_update_7002() due to a typo that would prevent table creation.
+ */
+function media_update_7021() {
+  media_update_7002();
+}
+
 /**
  * Replace 'view media' perm from all users having the role with 'view file'.
  */
@@ -1160,9 +1171,7 @@ function media_update_7225() {
 }
 
 /**
- * Accommodate the introduction of a new permission which restricts access to
- * the media browser by granting it to existing users who were able to access
- * it.
+ * Grant existing user access to new media browser permission.
  */
 function media_update_7226() {
   $roles = user_roles(FALSE, 'create files');
